%global gem_name rr
%global rubyabi 1.9.1

Summary: RR (Double Ruby) is a test double framework 
Name: rubygem-%{gem_name}
Version: 1.0.4
Release: 4%{?dist}
Group: Development/Languages
License: MIT
URL: http://pivotallabs.com
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
Requires: ruby(abi) = %{rubyabi}
Requires: ruby 
Requires: ruby(rubygems) 
BuildRequires: ruby 
BuildRequires: ruby(abi) = %{rubyabi}
BuildRequires: ruby 
BuildRequires: ruby-irb
BuildRequires: rubygems-devel
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

# The following are for running test suite
BuildRequires: rubygem(minitest)
BuildRequires: rubygem(session)
BuildRequires: rubygem(diff-lcs)

%description
RR (Double Ruby) is a test double framework that features a rich selection of
double techniques and a terse syntax.

A Test Double is a generalization of something that replaces a real object to
make it easier to test another object. Its like a stunt double for tests.

%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}


%prep
%setup -q -c -T
mkdir -p .%{gem_dir}
gem install --local --install-dir .%{gem_dir} \
            --force %{SOURCE0}

%build

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

# Remove leftovers.
rm  %{buildroot}%{gem_instdir}/.gitignore
rm  %{buildroot}%{gem_instdir}/.runrc
rm  %{buildroot}%{gem_instdir}/.rvmrc
rm  %{buildroot}%{gem_instdir}/Gemfile
rm  %{buildroot}%{gem_instdir}/Gemfile.lock
rm  %{buildroot}%{gem_instdir}/%{gem_name}.gemspec
rm  %{buildroot}%{gem_instdir}/doc/todo.txt
rm  %{buildroot}%{gem_dir}/cache/%{gem_name}-%{version}.gem
rm -rf  %{buildroot}%{gem_instdir}/.yardoc

# Fixing test-suite files to avoid bundler dependency
sed -i 's/require "bundler"/#require "bundler"/g' %{buildroot}%{gem_instdir}/spec/spec_suite.rb
sed -i 's/require "bundler"/#require "bundler"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb

# Removing rspec dependency for testunit and minitest tests
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb
sed -i 's/require "spec\/autorun"/#require "spec\/autorun"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_integration_test.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_backtrace_test.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_integration_test.rb

%check
cd %{buildroot}%{gem_instdir}
#ruby spec/spec_suite.rb
# Run individual test suites until test suite is updated to rspec 2x
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/test_unit/test_unit_integration_test.rb
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/test_unit/test_unit_backtrace_test.rb
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/minitest/minitest_integration_test.rb

# Remove leftovers.
rm  %{buildroot}%{gem_instdir}/Rakefile

%files
%dir %{gem_instdir}
%doc %{gem_instdir}/LICENSE
%{gem_libdir}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/doc
%doc %{gem_instdir}/introducting_rr.txt
%doc %{gem_instdir}/CHANGES
%doc %{gem_instdir}/README.rdoc
%{gem_instdir}/spec
%{gem_instdir}/benchmarks

%changelog
* Sun Feb 12 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-4
- Changelog entries fixed

* Tue Feb 07 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-3
- Updated spec file for Ruby 1.9 guidelines
- RSPec 1x tests disabled

* Tue Jan 24 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-2
- Removed unused macro from spec file
- Removed doc tag for benchmarks and spec file
- Removed cached version of the gem
- Fixed test suite files and test suite enabled at check section

* Sat Jan 21 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-1
- Initial package
